using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace AntiAliasing
{
 public partial class Form1 : Form
 {
  public Form1()
  {
   InitializeComponent();
  }

  int FigureATracer = 0;  // 0 : rien  tracer, 1 : diagonale, 2 : ellipse
  private void Form1_Paint(object sender, PaintEventArgs e)
  {
   if (FigureATracer != 0)
   {
    Rectangle rc = new Rectangle(250, 0, Width - 250, Height);
    Graphics g = CreateGraphics();
    g.FillRectangle(new SolidBrush(CouleurFond), rc);
    int Epaisseur = Int32.Parse(coEpaisseur.Text);
    switch (coMode.SelectedIndex)
    {
     case 0: g.SmoothingMode = SmoothingMode.HighSpeed; break;
     case 1: g.SmoothingMode = SmoothingMode.AntiAlias; break;
     case 2: g.SmoothingMode = SmoothingMode.HighQuality; break;
    }
    switch (FigureATracer)
    {
     case 1: g.DrawLine(new Pen(CouleurTrait, Epaisseur), 275, 20, ClientRectangle.Width - 20, ClientRectangle.Height - 20);
      break;
     case 2: g.DrawEllipse(new Pen(CouleurTrait, Epaisseur), 275, 20, ClientRectangle.Width - 300, ClientRectangle.Height - 40);
      break;
    }
   }
  }

  private void Form1_Load(object sender, EventArgs e)
  {
   coMode.SelectedIndex = 0;
   coEpaisseur.SelectedIndex = 0;
  }

  Color CouleurFond = Color.LightGray, CouleurTrait = Color.Black;

  private void bCouleurFond_Click(object sender, EventArgs e)
  {
   DialogResult res = diaCouleur.ShowDialog();
   if (res == DialogResult.OK)
   {
    CouleurFond = diaCouleur.Color;
    Invalidate(false);
   }
  }

  private void bCouleurTrait_Click(object sender, EventArgs e)
  {
   DialogResult res = diaCouleur.ShowDialog();
   if (res == DialogResult.OK)
   {
    CouleurTrait = diaCouleur.Color;
    Invalidate(false);
   }
  }

  private void bTracerDiagonale_Click(object sender, EventArgs e)
  {
   FigureATracer = 1;
   Invalidate(false);
  }

  private void bTracerEllipse_Click(object sender, EventArgs e)
  {
   FigureATracer = 2;
   Invalidate(false);
  }

  private void coMode_SelectedIndexChanged(object sender, EventArgs e)
  {
   Invalidate(false);
  }

  private void coEpaisseur_SelectedIndexChanged(object sender, EventArgs e)
  {
   Invalidate(false);
  }


 }
}